src/main/java/org/csd322/entities/Car.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.csd322.entities;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.Lob;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author fred
 */
@Entity
@Table(name = "car")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Car.findAll", query = "SELECT c FROM Car c"),
    @NamedQuery(name = "Car.findById", query = "SELECT c FROM Car c WHERE c.id = :id"),
    @NamedQuery(name = "Car.findByMake", query = "SELECT c FROM Car c WHERE c.make = :make"),
    @NamedQuery(name = "Car.findByModel", query = "SELECT c FROM Car c WHERE c.model = :model"),
    @NamedQuery(name = "Car.findByYear", query = "SELECT c FROM Car c WHERE c.year = :year"),
    @NamedQuery(name = "Car.findByUsed", query = "SELECT c FROM Car c WHERE c.used = :used"),
    @NamedQuery(name = "Car.findByType", query = "SELECT c FROM Car c WHERE c.type = :type"),
    @NamedQuery(name = "Car.findByBoughtFor", query = "SELECT c FROM Car c WHERE c.boughtFor = :boughtFor"),
    @NamedQuery(name = "Car.findBySoldFor", query = "SELECT c FROM Car c WHERE c.soldFor = :soldFor"),
    @NamedQuery(name = "Car.findBySellingPrice", query = "SELECT c FROM Car c WHERE c.sellingPrice = :sellingPrice"),
    @NamedQuery(name = "Car.findByOdometerKm", query = "SELECT c FROM Car c WHERE c.odometerKm = :odometerKm"),
    @NamedQuery(name = "Car.findByDateReceived", query = "SELECT c FROM Car c WHERE c.dateReceived = :dateReceived"),
    @NamedQuery(name = "Car.findByDateSold", query = "SELECT c FROM Car c WHERE c.dateSold = :dateSold")})
public class Car implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Size(max = 45)
    @Column(name = "make")
    private String make;
    @Size(max = 45)
    @Column(name = "model")
    private String model;
    @Column(name = "year")
    @Temporal(TemporalType.DATE)
    private Date year;
    @Lob
    @Column(name = "image")
    private byte[] image;
    @Column(name = "used")
    private Boolean used;
    @Size(max = 45)
    @Column(name = "type")
    private String type;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Column(name = "boughtFor")
    private Double boughtFor;
    @Column(name = "soldFor")
    private Double soldFor;
    @Column(name = "sellingPrice")
    private Double sellingPrice;
    @Column(name = "odometerKm")
    private Double odometerKm;
    @Column(name = "dateReceived")
    @Temporal(TemporalType.DATE)
    private Date dateReceived;
    @Column(name = "dateSold")
    @Temporal(TemporalType.DATE)
    private Date dateSold;
    @JoinTable(name = "special_has_car", joinColumns = {
        @JoinColumn(name = "car_id", referencedColumnName = "id")}, inverseJoinColumns = {
        @JoinColumn(name = "special_id", referencedColumnName = "id")})
    @ManyToMany
    private List<Special> specialList;
    @JoinColumn(name = "soldTo", referencedColumnName = "id")
    @ManyToOne
    private Person soldTo;

    public Car() {
    }

    public Car(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getMake() {
        return make;
    }

    public void setMake(String make) {
        this.make = make;
    }

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public Date getYear() {
        return year;
    }

    public void setYear(Date year) {
        this.year = year;
    }

    public byte[] getImage() {
        if(image==null)
            image=new byte[0];
        return image;
    }

    public void setImage(byte[] image) {
        this.image = image;
    }

    public Boolean getUsed() {
        return used;
    }

    public void setUsed(Boolean used) {
        this.used = used;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public Double getBoughtFor() {
        return boughtFor;
    }

    public void setBoughtFor(Double boughtFor) {
        this.boughtFor = boughtFor;
    }

    public Double getSoldFor() {
        return soldFor;
    }

    public void setSoldFor(Double soldFor) {
        this.soldFor = soldFor;
    }

    public Double getSellingPrice() {
        return sellingPrice;
    }

    public void setSellingPrice(Double sellingPrice) {
        this.sellingPrice = sellingPrice;
    }

    public Double getOdometerKm() {
        return odometerKm;
    }

    public void setOdometerKm(Double odometerKm) {
        this.odometerKm = odometerKm;
    }

    public Date getDateReceived() {
        return dateReceived;
    }

    public void setDateReceived(Date dateReceived) {
        this.dateReceived = dateReceived;
    }

    public Date getDateSold() {
        return dateSold;
    }

    public void setDateSold(Date dateSold) {
        this.dateSold = dateSold;
    }

    @XmlTransient
    public List<Special> getSpecialList() {
        return specialList;
    }

    public void setSpecialList(List<Special> specialList) {
        this.specialList = specialList;
    }

    public Person getSoldTo() {
        return soldTo;
    }

    public void setSoldTo(Person soldTo) {
        this.soldTo = soldTo;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Car)) {
            return false;
        }
        Car other = (Car) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "org.csd322.entities.Car[ id=" + id + " ]";
    }
    
}

src/main/java/org/csd322/jsfclasses/CarController.java
package org.csd322.jsfclasses;

import org.csd322.entities.Car;
import org.csd322.jsfclasses.util.JsfUtil;
import org.csd322.jsfclasses.util.PaginationHelper;
import org.csd322.sessionbeans.CarFacade;

import java.io.Serializable;
import java.util.ResourceBundle;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.faces.model.SelectItem;

@Named("carController")
@SessionScoped
public class CarController implements Serializable {

    private Car current;
    private DataModel items = null;
    @EJB
    private org.csd322.sessionbeans.CarFacade ejbFacade;
    private PaginationHelper pagination;
    private int selectedItemIndex;

    public CarController() {
    }

    public Car getSelected() {
        if (current == null) {
            current = new Car();
            selectedItemIndex = -1;
        }
        return current;
    }

    private CarFacade getFacade() {
        return ejbFacade;
    }

    public PaginationHelper getPagination() {
        if (pagination == null) {
            pagination = new PaginationHelper(10) {

                @Override
                public int getItemsCount() {
                    return getFacade().count();
                }

                @Override
                public DataModel createPageDataModel() {
                    return new ListDataModel(getFacade().findRange(new int[]{getPageFirstItem(), getPageFirstItem() + getPageSize()}));
                }
            };
        }
        return pagination;
    }

    public String prepareList() {
        recreateModel();
        return "List";
    }

    public String prepareView() {
        current = (Car) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "View";
    }

    public String prepareCreate() {
        current = new Car();
        selectedItemIndex = -1;
        return "Create";
    }

    public String create() {
        try {
            getFacade().create(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("CarCreated"));
            return prepareCreate();
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String prepareEdit() {
        current = (Car) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "Edit";
    }

    public String update() {
        try {
            getFacade().edit(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("CarUpdated"));
            return "View";
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String destroy() {
        current = (Car) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        performDestroy();
        recreatePagination();
        recreateModel();
        return "List";
    }

    public String destroyAndView() {
        performDestroy();
        recreateModel();
        updateCurrentItem();
        if (selectedItemIndex >= 0) {
            return "View";
        } else {
            // all items were removed - go back to list
            recreateModel();
            return "List";
        }
    }

    private void performDestroy() {
        try {
            getFacade().remove(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("CarDeleted"));
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
        }
    }

    private void updateCurrentItem() {
        int count = getFacade().count();
        if (selectedItemIndex >= count) {
            // selected index cannot be bigger than number of items:
            selectedItemIndex = count - 1;
            // go to previous page if last page disappeared:
            if (pagination.getPageFirstItem() >= count) {
                pagination.previousPage();
            }
        }
        if (selectedItemIndex >= 0) {
            current = getFacade().findRange(new int[]{selectedItemIndex, selectedItemIndex + 1}).get(0);
        }
    }

    public DataModel getItems() {
        if (items == null) {
            items = getPagination().createPageDataModel();
        }
        return items;
    }

    private void recreateModel() {
        items = null;
    }

    private void recreatePagination() {
        pagination = null;
    }

    public String next() {
        getPagination().nextPage();
        recreateModel();
        return "List";
    }

    public String previous() {
        getPagination().previousPage();
        recreateModel();
        return "List";
    }

    public SelectItem[] getItemsAvailableSelectMany() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), false);
    }

    public SelectItem[] getItemsAvailableSelectOne() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), true);
    }

    public Car getCar(java.lang.Integer id) {
        return ejbFacade.find(id);
    }

    @FacesConverter(forClass = Car.class)
    public static class CarControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            CarController controller = (CarController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "carController");
            return controller.getCar(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof Car) {
                Car o = (Car) object;
                return getStringKey(o.getId());
            } else {
                throw new IllegalArgumentException("object " + object + " is of type " + object.getClass().getName() + "; expected type: " + Car.class.getName());
            }
        }

    }

}

src/main/webapp/jsf/car/Create.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.CreateCarTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.CreateCarLabel_id}" for="id" />
                    <h:inputText id="id" value="#{carController.selected.id}" title="#{bundle.CreateCarTitle_id}" required="true" requiredMessage="#{bundle.CreateCarRequiredMessage_id}"/>
                    <h:outputLabel value="#{bundle.CreateCarLabel_make}" for="make" />
                    <h:inputText id="make" value="#{carController.selected.make}" title="#{bundle.CreateCarTitle_make}" />
                    <h:outputLabel value="#{bundle.CreateCarLabel_model}" for="model" />
                    <h:inputText id="model" value="#{carController.selected.model}" title="#{bundle.CreateCarTitle_model}" />
                    <h:outputLabel value="#{bundle.CreateCarLabel_year}" for="year" />
                    <h:inputText id="year" value="#{carController.selected.year}" title="#{bundle.CreateCarTitle_year}" >
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.CreateCarLabel_used}" for="used" />
                    <h:inputText id="used" value="#{carController.selected.used}" title="#{bundle.CreateCarTitle_used}" />
                    <h:outputLabel value="#{bundle.CreateCarLabel_type}" for="type" />
                    <h:inputText id="type" value="#{carController.selected.type}" title="#{bundle.CreateCarTitle_type}" />
                    <h:outputLabel value="#{bundle.CreateCarLabel_boughtFor}" for="boughtFor" />
                    <h:inputText id="boughtFor" value="#{carController.selected.boughtFor}" title="#{bundle.CreateCarTitle_boughtFor}" />
                    <h:outputLabel value="#{bundle.CreateCarLabel_soldFor}" for="soldFor" />
                    <h:inputText id="soldFor" value="#{carController.selected.soldFor}" title="#{bundle.CreateCarTitle_soldFor}" />
                    <h:outputLabel value="#{bundle.CreateCarLabel_sellingPrice}" for="sellingPrice" />
                    <h:inputText id="sellingPrice" value="#{carController.selected.sellingPrice}" title="#{bundle.CreateCarTitle_sellingPrice}" />
                    <h:outputLabel value="#{bundle.CreateCarLabel_odometerKm}" for="odometerKm" />
                    <h:inputText id="odometerKm" value="#{carController.selected.odometerKm}" title="#{bundle.CreateCarTitle_odometerKm}" />
                    <h:outputLabel value="#{bundle.CreateCarLabel_dateReceived}" for="dateReceived" />
                    <h:inputText id="dateReceived" value="#{carController.selected.dateReceived}" title="#{bundle.CreateCarTitle_dateReceived}" >
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.CreateCarLabel_dateSold}" for="dateSold" />
                    <h:inputText id="dateSold" value="#{carController.selected.dateSold}" title="#{bundle.CreateCarTitle_dateSold}" >
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.CreateCarLabel_soldTo}" for="soldTo" />
                    <h:selectOneMenu id="soldTo" value="#{carController.selected.soldTo}" title="#{bundle.CreateCarTitle_soldTo}" >
                        <f:selectItems value="#{personController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{carController.create}" value="#{bundle.CreateCarSaveLink}" />
                <br />
                <br />
                <h:commandLink action="#{carController.prepareList}" value="#{bundle.CreateCarShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.CreateCarIndexLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

src/main/webapp/jsf/car/Edit.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.EditCarTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.EditCarLabel_id}" for="id" />
                    <h:inputText id="id" value="#{carController.selected.id}" title="#{bundle.EditCarTitle_id}" required="true" requiredMessage="#{bundle.EditCarRequiredMessage_id}"/>
                    <h:outputLabel value="#{bundle.EditCarLabel_make}" for="make" />
                    <h:inputText id="make" value="#{carController.selected.make}" title="#{bundle.EditCarTitle_make}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_model}" for="model" />
                    <h:inputText id="model" value="#{carController.selected.model}" title="#{bundle.EditCarTitle_model}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_year}" for="year" />
                    <h:inputText id="year" value="#{carController.selected.year}" title="#{bundle.EditCarTitle_year}" >
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.EditCarLabel_image}" for="image" />
                    <h:inputTextarea rows="4" cols="30" id="image" value="#{carController.selected.image}" title="#{bundle.EditCarTitle_image}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_used}" for="used" />
                    <h:inputText id="used" value="#{carController.selected.used}" title="#{bundle.EditCarTitle_used}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_type}" for="type" />
                    <h:inputText id="type" value="#{carController.selected.type}" title="#{bundle.EditCarTitle_type}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_boughtFor}" for="boughtFor" />
                    <h:inputText id="boughtFor" value="#{carController.selected.boughtFor}" title="#{bundle.EditCarTitle_boughtFor}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_soldFor}" for="soldFor" />
                    <h:inputText id="soldFor" value="#{carController.selected.soldFor}" title="#{bundle.EditCarTitle_soldFor}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_sellingPrice}" for="sellingPrice" />
                    <h:inputText id="sellingPrice" value="#{carController.selected.sellingPrice}" title="#{bundle.EditCarTitle_sellingPrice}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_odometerKm}" for="odometerKm" />
                    <h:inputText id="odometerKm" value="#{carController.selected.odometerKm}" title="#{bundle.EditCarTitle_odometerKm}" />
                    <h:outputLabel value="#{bundle.EditCarLabel_dateReceived}" for="dateReceived" />
                    <h:inputText id="dateReceived" value="#{carController.selected.dateReceived}" title="#{bundle.EditCarTitle_dateReceived}" >
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.EditCarLabel_dateSold}" for="dateSold" />
                    <h:inputText id="dateSold" value="#{carController.selected.dateSold}" title="#{bundle.EditCarTitle_dateSold}" >
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.EditCarLabel_soldTo}" for="soldTo" />
                    <h:selectOneMenu id="soldTo" value="#{carController.selected.soldTo}" title="#{bundle.EditCarTitle_soldTo}" >
                        <f:selectItems value="#{personController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                </h:panelGrid>
                <h:commandLink action="#{carController.update}" value="#{bundle.EditCarSaveLink}"/>
                <br />
                <br />
                <h:link outcome="View" value="#{bundle.EditCarViewLink}"/>
                <br />
                <h:commandLink action="#{carController.prepareList}" value="#{bundle.EditCarShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.EditCarIndexLink}" />
            </h:form>
        </ui:define>
    </ui:composition>

</html>

src/main/webapp/jsf/car/View.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ViewCarTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputText value="#{bundle.ViewCarLabel_id}"/>
                    <h:outputText value="#{carController.selected.id}" title="#{bundle.ViewCarTitle_id}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_make}"/>
                    <h:outputText value="#{carController.selected.make}" title="#{bundle.ViewCarTitle_make}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_model}"/>
                    <h:outputText value="#{carController.selected.model}" title="#{bundle.ViewCarTitle_model}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_year}"/>
                    <h:outputText value="#{carController.selected.year}" title="#{bundle.ViewCarTitle_year}">
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:outputText>
                    <h:outputText value="#{bundle.ViewCarLabel_image}"/>
                    <h:outputText value="#{carController.selected.image}" title="#{bundle.ViewCarTitle_image}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_used}"/>
                    <h:outputText value="#{carController.selected.used}" title="#{bundle.ViewCarTitle_used}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_type}"/>
                    <h:outputText value="#{carController.selected.type}" title="#{bundle.ViewCarTitle_type}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_boughtFor}"/>
                    <h:outputText value="#{carController.selected.boughtFor}" title="#{bundle.ViewCarTitle_boughtFor}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_soldFor}"/>
                    <h:outputText value="#{carController.selected.soldFor}" title="#{bundle.ViewCarTitle_soldFor}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_sellingPrice}"/>
                    <h:outputText value="#{carController.selected.sellingPrice}" title="#{bundle.ViewCarTitle_sellingPrice}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_odometerKm}"/>
                    <h:outputText value="#{carController.selected.odometerKm}" title="#{bundle.ViewCarTitle_odometerKm}"/>
                    <h:outputText value="#{bundle.ViewCarLabel_dateReceived}"/>
                    <h:outputText value="#{carController.selected.dateReceived}" title="#{bundle.ViewCarTitle_dateReceived}">
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:outputText>
                    <h:outputText value="#{bundle.ViewCarLabel_dateSold}"/>
                    <h:outputText value="#{carController.selected.dateSold}" title="#{bundle.ViewCarTitle_dateSold}">
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:outputText>
                    <h:outputText value="#{bundle.ViewCarLabel_soldTo}"/>
                    <h:outputText value="#{carController.selected.soldTo}" title="#{bundle.ViewCarTitle_soldTo}"/>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{carController.destroyAndView}" value="#{bundle.ViewCarDestroyLink}"/>
                <br />
                <br />
                <h:link outcome="Edit" value="#{bundle.ViewCarEditLink}"/>
                <br />
                <h:commandLink action="#{carController.prepareCreate}" value="#{bundle.ViewCarCreateLink}" />
                <br />
                <h:commandLink action="#{carController.prepareList}" value="#{bundle.ViewCarShowAllLink}"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.ViewCarIndexLink}"/>

            </h:form>
        </ui:define>
    </ui:composition>

</html>